(*  GREATIS KEYBOARD HOOK                                    *)
(*  Copyright (C) 2005-2014 Greatis Software                 *)
(*                                                           *)
(*  http://www.greatis.com/delphicb/keyboardhook/            *)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KeyboardHook, StdCtrls, ShellAPI, Menus;

type
  TFormMain = class(TForm)
    ButtonMore: TButton;
    ButtonClose: TButton;
    ButtonStartStop: TButton;
    KeyboardHook: TKeyboardHook;
    MemoOnKeyboardHook: TMemo;
    LabelOnKeyboardHook: TLabel;
    LabelOnKeyboardEvents: TLabel;
    MemoOnKeyboardEvents: TMemo;
    MemoEnteredText: TMemo;
    LabelOnChars: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonMoreClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonStartStopClick(Sender: TObject);
    procedure KeyboardHookKeyboardHook(Sender: TObject; VirtualKeyCode,
      ScanCode, Flags, Time: Integer; ExtraInfo: Pointer);
    procedure KeyboardHookKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KeyboardHookKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KeyboardHookChars(Sender: TObject; Chars: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

procedure TFormMain.FormCreate(Sender: TObject);
var
  LF: TLogFont;
begin
  SystemParametersInfo(SPI_GETICONTITLELOGFONT,SizeOf(LF),@LF,0);
  with LF,Font do
  begin
    ScaleBy(Abs(lfHeight),Abs(Height));
    Handle:=CreateFontIndirect(LF);
  end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  KeyboardHook.Active:=True;
end;

procedure TFormMain.ButtonMoreClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','http://www.greatis.com/delphicb/keyboardhook/',nil,nil,SW_SHOWDEFAULT);
end;

procedure TFormMain.ButtonCloseClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFormMain.ButtonStartStopClick(Sender: TObject);
begin
  with KeyboardHook,ButtonStartStop do
  begin
    Active:=not Active;
    if Active then Caption:='Stop'
    else Caption:='Start';
  end;
end;

procedure TFormMain.KeyboardHookKeyboardHook(Sender: TObject;
  VirtualKeyCode, ScanCode, Flags, Time: Integer; ExtraInfo: Pointer);
begin
  MemoOnKeyboardHook.Lines.Add(
    IntToHex(VirtualKeyCode,8)+' '+
    IntToHex(ScanCode,8)+' '+
    IntToHex(Flags,8)+' '+
    IntToHex(Time,8)+' '+
    IntToHex(Integer(ExtraInfo),8));
end;

procedure TFormMain.KeyboardHookKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  MemoOnKeyboardEvents.Lines.Add('OnKeyDown '+ShortCutToText(ShortCut(Key,Shift)));
end;

procedure TFormMain.KeyboardHookKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  MemoOnKeyboardEvents.Lines.Add('OnKeyUp '+ShortCutToText(ShortCut(Key,Shift)));
end;

procedure TFormMain.KeyboardHookChars(Sender: TObject; Chars: String);
begin
  with MemoEnteredText do Text:=Text+Chars;
end;

end.
